'use strict';

var _ = require("underscore.string");
var chalk = require("chalk");
var generators = require("yeoman-generator");
var path = require("path");
var yosay = require("yosay");

module.exports = generators.Base.extend({
  constructor: function () {
    generators.Base.apply(this, arguments);
  },

  prompting: {
    welcomeMessage: function() {
      this.log(yosay());
      this.log(chalk.magenta("Hey! I will generate the structure of the Angular2 application based on the project: https://github.com/ocombe/ng2-webpack\n"))
    }
  },

  writing: {
    copyTemplateFiles: function() {
      this.directory(this.sourceRoot(), this.destinationRoot());
    }

  },

  install: {
    installNpmDependencies: function() {
      this.npmInstall();
    }
  },

  end: {
    helpMessage: function() {
      this.log(chalk.yellow("The project use in background angular-cli, so please visit: https://github.com/angular/angular-cli to see the available generators.\n"));
    },

    startNpm: function() {
      this.spawnCommand("npm", ["start"]);
    }
  }
});
